<?php defined('SYSPATH') OR die('No direct access allowed.');
/**
 * Synergy Widget
 *
 * @package    NINJA
 * @author     op5 AB
 * @license    GPL
 */
class Tac_synergy_Widget extends widget_Base {
	protected $duplicatable = true;

	/**
	 * Return the default friendly name for the widget type
	 *
	 * default to the model name, but should be overridden by widgets.
	 */
	public function get_metadata() {
		return array_merge(parent::get_metadata(), array(
			'friendly_name' => 'Business Services',
			'instanceable' => true
		));
	}

	function options()
	{
		$options = parent::options();
		$options[] = new option('tac_synergy', 'hide_ok', 'Hide OK states', 'checkbox', array(), false);
		return $options;
	}

	static function sort_by_most_serious_condition($a, $b) {
		if($a['result']['status'] == $b['result']['status']) {
			return 0;
		}
		return $a['result']['status'] < $b['result']['status'] ? 1 : -1;
	}

	function index()
	{
		try {
			$rules = Synergy_Model::getTopsList();

			$arguments = $this->get_arguments();
			if($arguments['hide_ok'] && !empty($rules)) {
				foreach($rules as $rule => $definition) {
					if($definition['result']['status'] == 0) {
						unset($rules[$rule]);
					}
				}
			}

			// we want to list the non ok states first
			uasort($rules, array(__CLASS__, 'sort_by_most_serious_condition'));

			$states = array(
				0 => 'ok',
				1 => 'warning',
				2 => 'critical',
				3 => 'unknown',
			);

			require $this->view_path('view');
		} catch(SynergyException $e) {
			/* TODO: Butify */
			print "<div class=\"alert error\"><strong>Error:</strong> " . $e->getMessage() . "</div>";
		}
	}
}
